var LookAtTarget:Transform;
var damp = 1.0;
var bulletPrefab:Transform;
var savedTime = 0;
var range = 15;

function Start() {
	var go = GameObject.FindWithTag("Player");
	LookAtTarget =  go.transform;
}

function Update () {

	if (LookAtTarget)
	{
	
		var seconds : int = Time.time;
		var oddeven = (seconds % 2);
		
		
			var rotate = Quaternion.LookRotation(LookAtTarget.position - transform.position);
			transform.rotation = Quaternion.Slerp(transform.rotation, rotate, Time.deltaTime * damp);
		
		if (oddeven){
			var distance = Vector3.Distance(LookAtTarget.position, transform.position);
			if (distance<range){
			Shoot(seconds);
		}
		}
	}

}

function Shoot(seconds){

	if (seconds!=savedTime){
		var bullet = Instantiate(bulletPrefab, transform.Find("turrentGun").Find("spawnPoint").transform.position, transform.rotation);
		bullet.gameObject.tag = "enemyProjectileRocket";
		bullet.rigidbody.AddForce(transform.forward * 100);
		savedTime = seconds;
		}

}