var LookAtTarget:Transform;
var damp = 2.0;
var bulletPrefab:Transform;
var savedTime = 0;
var range = 40;
var fireRate = 1.5;
private var nextFire = 0.0;

function Start() {
	var go = GameObject.FindWithTag("Player");
	LookAtTarget =  go.transform;
	nextFire = Time.time + fireRate;
}

function Update () {

	if (LookAtTarget)
	{
		var rotate = Quaternion.LookRotation(LookAtTarget.position - transform.position);
		transform.rotation = Quaternion.Slerp(transform.rotation, rotate, Time.deltaTime * damp);
		
		
		var distance = Vector3.Distance(LookAtTarget.position, transform.position);
		if (distance<range){
			if (Time.time > nextFire){
				Shoot();
			}
		}
	}

}

function Shoot(){
		nextFire = Time.time + fireRate;
		var bullet = Instantiate(bulletPrefab, transform.Find("turrentGun").Find("spawnPoint").transform.position, transform.rotation);
		bullet.gameObject.tag = "enemyProjectileRocket";
		bullet.rigidbody.AddForce(transform.forward * 100);
		

}