var health = 20.0;
var injurable = true;
var explosion : Transform;
var explosion2 : Transform;
var laserHit: Transform;
var fireHit: Transform;
var keyDrop: Transform;
var rockDrop: Transform;
var newKey;
var isKeyMaster = false;
var scoreFor = 0;
var isBoss = false;

function LateUpdate(){
	
	if (health <= 0){
		var exp = Instantiate(explosion, gameObject.transform.position, Quaternion.identity);
		Destroy(gameObject);
		if (isKeyMaster){
			newKey = Instantiate(keyDrop, gameObject.transform.position, Quaternion.identity);
		}
		ScoreControl.currentScore += scoreFor;
		if (isBoss){
			floorDisplay.CURRENTFLOOR += 1;
			Application.LoadLevel(floorDisplay.CURRENTFLOOR);
		}
	}
}

function setAsKeyMaster(){
	isKeyMaster = true;
}

function OnTriggerEnter(hit: Collider)	{
	if (hit.gameObject.tag == "playerProjectile")
	{
		health -=8;
		Destroy(hit.gameObject);
		var lH = Instantiate(laserHit, hit.gameObject.transform.position, Quaternion.identity);
		
	}else if (hit.gameObject.tag == "playerProjectileRocket")
	{
		var exp2 = Instantiate(explosion2, hit.gameObject.transform.position, Quaternion.identity);
		health -= 50;
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "playerProjectileFire")
	{
		var fH = Instantiate(fireHit, gameObject.transform.position, Quaternion.identity);
		health -= 2;
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "playerProjectileLaser")
	{
		health -=15;
		Destroy(hit.gameObject);
		var pH = Instantiate(laserHit, hit.gameObject.transform.position, Quaternion.identity);
		
	}else if (hit.gameObject.tag == "playerProjectileWater")
	{
		var wH = Instantiate(laserHit, hit.gameObject.transform.position, Quaternion.identity);
		health -= 1;
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "playerProjectileDisint")
	{
		var exp3 = Instantiate(explosion2, hit.gameObject.transform.position, Quaternion.identity);
		health -= 80;
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "playerProjectileVuvu")
	{
		var vH = Instantiate(laserHit, gameObject.transform.position, Quaternion.identity);
		health -= 2;
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "playerProjectileSpg")
	{
		var spgH = Instantiate(laserHit, gameObject.transform.position, Quaternion.identity);
		health -= 2;
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "playerProjectileSpc")
	{
		var spcH = Instantiate(laserHit, gameObject.transform.position, Quaternion.identity);
		health -= 4;
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "playerProjectileRock")
	{
		var newRock = Instantiate(rockDrop, hit.gameObject.transform.position, Quaternion.identity);
		var damage = 35.0 * PlayerController.rockMultiplier;
		print(damage);
		health -= damage;
		print(health);
		PlayerController.rockMultiplier = 1.0;
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "deathBubble")
	{
		exp2 = Instantiate(explosion2, hit.gameObject.transform.position, Quaternion.identity);
		health -= 130;
	}else if (hit.gameObject.tag == "healBubble")
	{
		health += 30;
	}
	
}	

		