//***********************************//
//          init prefabs             //
//***********************************//
var roomN : Transform;
var roomS : Transform;
var roomE : Transform;
var roomW : Transform;

var roomNS : Transform;
var roomNE : Transform;
var roomNW : Transform;

var roomNSE : Transform;
var roomNSW : Transform;
var roomNEW : Transform;

var roomNSEW : Transform;

var roomSE : Transform;
var roomSW : Transform;

var roomSEW : Transform;

var roomEW : Transform;

var roomD : Transform;

var rocketTurret : Transform;
var fireTurret: Transform;
var simpleTurret : Transform;

var badGuy : Transform;
var fireGuy : Transform;
var rocketGuy : Transform;

var chaser : Transform;

var bubblePickUp : Transform;
var firePickUp : Transform;
var rocketPickUp : Transform;
var rockPickUp : Transform;
var spreadPickUp : Transform;
var soakerPickUp : Transform;
var pewPickUp : Transform;
var disintPickUp : Transform;
var vuvuPickUp : Transform;
var spcPickUp : Transform;
var spgPickUp : Transform;

var levelUp : Transform;

var vertDoor : Transform;
var horizDoor : Transform;

var aPylon : Transform;
var aFootball : Transform;
var aCowboy : Transform;
var aViking : Transform;
var aPope : Transform;
var aSquid : Transform;
var aTophat : Transform;
var aSlug : Transform;

var redCap : Transform;
var grnCap : Transform;
var bluCap : Transform;
var prpCap : Transform;


//***********************************//
//         init Room stats           //
//***********************************//

var itemGenSeed: int;
var enemyGenSeed = 12;

var Xspace = 22;
var Yspace = 12;

var roomXLength = 7;
var roomYLength = 5;
private var canBeN = true;
private var canBeS = true;
private var canBeE = true;
private var canBeW = true;
private var needN = false;
private var needS = false;
private var needE = false;
private var needW = false;
private var roomOptions = new Array();

var startX : int;
var startY : int;

roomOptions.Add(2);
roomOptions.Add(3);
roomOptions.Add(5);
roomOptions.Add(7);
roomOptions.Add(6);
roomOptions.Add(10);
roomOptions.Add(14);
roomOptions.Add(30);
roomOptions.Add(42);
roomOptions.Add(70);
roomOptions.Add(15); 
roomOptions.Add(21);
roomOptions.Add(105);
roomOptions.Add(35); 
roomOptions.Add(210);
var spliced = false;

private var roomArray = new Array(roomXLength);
private var roomAccess = new Array(roomXLength);
for (var x2 = 0; x2 < roomXLength; x2++){
roomArray[x2] = new Array(roomYLength); // Make the first element an array of two elements
roomAccess[x2] = new Array(roomYLength);
}

private var spawnedEnemyCount = 0;
private var reachableRooms = 0;

//*************************//
//    ENEMY ALLOWANCES     //
//*************************//
var canHaveLaserDudes = true;
var canHaveFireDudes = true;
var canHaveRocketDudes = true;
var canHaveLaserTowers = true;
var canHaveFireTowers = true;
var canHaveRocketTowers = true;
var canHaveChasers = false;


var enemyOptions = new Array();
if (canHaveLaserDudes) enemyOptions.Add(3);
if (canHaveFireDudes) enemyOptions.Add(4); 
if (canHaveRocketDudes) enemyOptions.Add(5);
if (canHaveLaserTowers) enemyOptions.Add(0);
if (canHaveFireTowers) enemyOptions.Add(1);
if (canHaveRocketTowers) enemyOptions.Add(2);
if (canHaveChasers) enemyOptions.Add(6);


//***********************************//
//           gen Rooms	             //
//***********************************//
	for(var x = 0; x < roomXLength; x++){
		for(var y = 0; y < roomYLength; y++){
		roomAccess[x][y] = 0;
		if (!roomArray[x][y]){ //if room not set yet
			
			canBeN = true;	//reset flags
			canBeS = true;
			canBeE = true;
			canBeW = true;
			needN = false;
			needS = false;
			needE = false;
			needW = false;

			//checkLeft
			if (x == 0) {canBeW = false;}
			else if (roomArray[x-1][y])
				if (roomArray[x-1][y] % 5 == 0) {needW = true;}
					else {canBeW = false;}
			//checkRight	
			if (x == roomXLength-1){canBeE = false;}
			else if (roomArray[x+1][y])
				if (roomArray[x+1][y] % 7 == 0) {needE = true;}
					else {canBeE = false;}
			//checkUp
			if (y == 0) {canBeN = false;}
			else if (roomArray[x][y-1])
				if (roomArray[x][y-1] % 3 == 0) {needN = true;}
					else {canBeN = false;}
			//checkDown
			if (y == roomYLength-1){canBeS = false;}
			else if (roomArray[x][y+1])
				if (roomArray[x][y+1] % 2 == 0) {needS = true;}
					else {canBeS = false;}
			
			for (var z = roomOptions.length; z > 0; z--){
				room = roomOptions[z-1];
				if (!canBeE && !spliced){
					if (room % 5 == 0) {roomOptions.RemoveAt(z-1); spliced = true;}
				}
				if (!canBeN && !spliced){
					if (room % 2 == 0) {roomOptions.RemoveAt(z-1); spliced = true;}
				}
				if (!canBeS && !spliced){
					if (room % 3 == 0) {roomOptions.RemoveAt(z-1); spliced = true;}
				}
				if (!canBeW && !spliced){
					if (room % 7 == 0) {roomOptions.RemoveAt(z-1); spliced = true;}
				}
				if (needE && !spliced){
					if (room % 5 != 0) {roomOptions.RemoveAt(z-1); spliced = true;}
				}
				if (needN && !spliced){
					if (room % 2 != 0) {roomOptions.RemoveAt(z-1); spliced = true;}
				}
				if (needS && !spliced){
					if (room % 3 != 0) {roomOptions.RemoveAt(z-1); spliced = true;}
				}
				if (needW && !spliced){
					if (room % 7 != 0) {roomOptions.RemoveAt(z-1); spliced = true;}
				}
				spliced = false;
			} 
			if(roomOptions.length == 0){roomArray[x][y]=1; print("there's a dead room!");}
			else
			roomArray[x][y] = roomOptions[Random.Range(0,roomOptions.length)];
			print(roomArray[x][y]);
			roomOptions = [2, 3, 5, 7, 6, 10, 14, 30, 42, 70, 15, 21, 105, 35, 210];
			}
	}
	
}



//***********************************//
//           add Exit	             //
//***********************************//

private var foundEnd = false;
private var triedExits = 0;
private var checkX: int;
checkX = startX;
private var checkY: int;
checkY = startY;
private var lastX = checkX;
private var lastY = checkY;
	print('x'+startX+'y'+startY);
	
	print('x'+checkX+'y'+checkY);
for (var searchCount = 2; searchCount > 1; searchCount++){
	if (searchCount == 20) {searchCount = 0;}
	roomAccess[checkX][checkY] = 1;
	var startDoor = Random.Range(0,4);
	var someRoom = roomArray[checkX][checkY];
	var escapePos;
	var ladder;
	var stuck = true;
	switch(startDoor){
		case 0:
			if (someRoom% 2 == 0 && checkY > 0){
				if (roomAccess[checkX][checkY-1] == 0){
					lastX = checkX;
					lastY = checkY;
					checkY-=1;
		//			print("wentNorth");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 3 == 0 && checkY < roomYLength - 1){
				if (roomAccess[checkX][checkY+1] == 0){
					lastX = checkX;
					lastY = checkY;
					checkY+=1;
		//			print("wentSouth");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 7 == 0 && checkX > 0){
				if (roomAccess[checkX-1][checkY] == 0){
					lastX = checkX;
					lastY = checkY;
					checkX-=1;
		//			print("wentWest");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 5 == 0 && checkX < roomXLength - 1){
				if (roomAccess[checkX+1][checkY] == 0){
					lastX = checkX;
					lastY = checkY;
					checkX+=1;
		//			print("wentEast");
					stuck = false;
				}
			}
			if (stuck) {
		//		print("stuck");
				searchCount = 0;
				escapePos = Vector3(checkX*Xspace, 1.1, checkY*-Yspace);
				ladder = Instantiate(levelUp, escapePos, Quaternion.identity);
				ladder.gameObject.tag = "levelUp";
				addDoors(checkX,checkY);
			}	
		break;
		
		case 1:
			if (someRoom% 3 == 0 && checkY < roomYLength - 1){
				if (roomAccess[checkX][checkY+1] == 0){
					lastX = checkX;
					lastY = checkY;
					checkY+=1;
		//			print("wentSouth");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 7 == 0 && checkX > 0){
				if (roomAccess[checkX-1][checkY] == 0){
					lastX = checkX;
					lastY = checkY;
					checkX-=1;
		//			print("wentWest");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 5 == 0 && checkX < roomXLength - 1){
				if (roomAccess[checkX+1][checkY] == 0){
					lastX = checkX;
					lastY = checkY;
					checkX+=1;
			//		print("wentEast");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 2 == 0 && checkY > 0){
				if (roomAccess[checkX][checkY-1] == 0){
					lastX = checkX;
					lastY = checkY;
					checkY-=1;
			//		print("wentNorth");
					stuck = false;
				}
			}
			if (stuck) {
	//			print("stuck");
				searchCount = 0;
				escapePos = Vector3(checkX*Xspace, 1.1, checkY*-Yspace);
				ladder = Instantiate(levelUp, escapePos, Quaternion.identity);
				ladder.gameObject.tag = "levelUp";
				addDoors(checkX,checkY);
			}
		break;
		
		case 2:
			if (someRoom% 7 == 0 && checkX > 0){
				if (roomAccess[checkX-1][checkY] == 0){
					lastX = checkX;
					lastY = checkY;
					checkX-=1;
		//			print("wentWest");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 5 == 0 && checkX < roomXLength - 1){
				if (roomAccess[checkX+1][checkY] == 0){
					lastX = checkX;
					lastY = checkY;
					checkX+=1;
		//			print("wentEast");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 2 == 0 && checkY > 0){
				if (roomAccess[checkX][checkY-1] == 0){
					lastX = checkX;
					lastY = checkY;
					checkY-=1;
			//		print("wentNorth");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 3 == 0 && checkY < roomYLength - 1){
				if (roomAccess[checkX][checkY+1] == 0){
					lastX = checkX;
					lastY = checkY;
					checkY+=1;
			//		print("wentSouth");
					stuck = false;
				}
			}
			if(stuck) {
		//		print("stuck");
				searchCount = 0;
				escapePos = Vector3(checkX*Xspace, 1.1, checkY*-Yspace);
				ladder = Instantiate(levelUp, escapePos, Quaternion.identity);
				ladder.gameObject.tag = "levelUp";
				addDoors(checkX,checkY);
			}
		break;
		
		case 3:
			if (someRoom% 5 == 0 && checkX < roomXLength - 1){
				if (roomAccess[checkX+1][checkY] == 0){
					lastX = checkX;
					lastY = checkY;
					checkX+=1;
	//				print("wentEast");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 2 == 0 && checkY > 0){
				if (roomAccess[checkX][checkY-1] == 0){
					lastX = checkX;
					lastY = checkY;
					checkY-=1;
		//			print("wentNorth");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 3 == 0 && checkY < roomYLength - 1){
				if (roomAccess[checkX][checkY+1] == 0){
					lastX = checkX;
					lastY = checkY;
					checkY+=1;
	//				print("wentSouth");
					stuck = false;
				}
			}
			if (stuck) if (someRoom% 7 == 0 && checkX > 0){
				if (roomAccess[checkX-1][checkY] == 0){
					lastY = checkY;
					lastX = checkX;
					checkX-=1;
		//			print("wentWest");
					stuck = false;
				}
			}
			if (stuck) {
		//		print("stuck");
				searchCount = 0;
				escapePos = Vector3(checkX*Xspace, 1.1, checkY*-Yspace);
				ladder = Instantiate(levelUp, escapePos, Quaternion.identity);
				ladder.gameObject.tag = "levelUp";
				addDoors(checkX,checkY);
			}
		break;
	}
//print(checkX +", "+checkY);
}

//print(lastX+", "+lastY+" done");

roomAccess[checkX][checkY] = 4;
AccessibleRooms(lastX,lastY);


function spawnGuarantee(firstPos, secondPos){
	var choice: int;
	choice = Random.Range(0,enemyOptions.length);
	spawnEnemy(enemyOptions[choice],secondPos,firstPos);
}
			
function spawnEnemy(enemyID, runnerHeight, turretHeight){
	switch (enemyID){
		case 0:
			if (canHaveLaserTowers){
			Instantiate(simpleTurret, turretHeight, Quaternion.identity);
			spawnedEnemyCount ++;
			}
		break;
		case 1:
			if (canHaveFireTowers){
			Instantiate(fireTurret, turretHeight, Quaternion.identity);
			spawnedEnemyCount ++;
			}
		break;
		case 2:
			if (canHaveRocketTowers){
			Instantiate(rocketTurret, turretHeight, Quaternion.identity);
			spawnedEnemyCount ++;
			}
		break;
		case 3:
			if (canHaveLaserDudes){
			Instantiate(badGuy, runnerHeight, Quaternion.identity);
			spawnedEnemyCount ++;
			}
		break;
		case 4:
			if (canHaveFireDudes){
			Instantiate(fireGuy, runnerHeight, Quaternion.identity);
			spawnedEnemyCount ++;
			}
		break;
		case 5:
			if (canHaveRocketDudes){
			Instantiate(rocketGuy, runnerHeight, Quaternion.identity);
			spawnedEnemyCount ++;
			}
		break;
		case 6:
			if (canHaveChasers){
			Instantiate(chaser, runnerHeight, Quaternion.identity);
			spawnedEnemyCount ++;
			}
		break;
	}
}

//***********************************//
//           add Dudes	             //
//***********************************//
	for(var y3 = 0; y3 < roomYLength; y3++){
		for(var x3 = 0; x3 < roomXLength; x3++){
		//	print (roomAccess[x3][y3]+",");
			var pos = Vector3(x3*Xspace, 0, y3*-Yspace);
			switch(roomArray[x3][y3]){
				case 2:
					Instantiate(roomN, pos, Quaternion.identity);
				break;
				case 3:
					Instantiate(roomS, pos, Quaternion.identity);
				break;
				case 7:
					Instantiate(roomW, pos, Quaternion.identity);
				break;
				case 5:
					Instantiate(roomE, pos, Quaternion.identity);
				break;
				case 6:
					Instantiate(roomNS, pos, Quaternion.identity);
				break;
				case 14:
					Instantiate(roomNW, pos, Quaternion.identity);
				break;
				case 10:
					Instantiate(roomNE, pos, Quaternion.identity);
				break;
				case 42:
					Instantiate(roomNSW, pos, Quaternion.identity);
				break;
				case 30:
					Instantiate(roomNSE, pos, Quaternion.identity);
				break;
				case 210:
					Instantiate(roomNSEW, pos, Quaternion.identity);
				break;
				case 70:
					Instantiate(roomNEW, pos, Quaternion.identity);
				break;
				case 21:
					Instantiate(roomSW, pos, Quaternion.identity);
				break;
				case 15:
					Instantiate(roomSE, pos, Quaternion.identity);
				break;
				case 105:
					Instantiate(roomSEW, pos, Quaternion.identity);
				break;
				case 35:
					Instantiate(roomEW, pos, Quaternion.identity);
				break;
				case 1:
					Instantiate(roomD, pos, Quaternion.identity);
				break;
			}
			//spawning enemies
			var whichDude = 0;
			var posA;
			var posB;
			if (roomAccess[x3][y3] == 3){
			//right
			whichDude = Random.Range(0,enemyGenSeed);
			posA = Vector3(x3*Xspace+6, 2, y3*-Yspace-2);
			posB = Vector3(x3*Xspace+6, 3.1, y3*-Yspace-2);
			if (whichDude < enemyOptions.length){
				whichDude = enemyOptions[whichDude];
			}
			spawnEnemy(whichDude, posB, posA);
			//left
			whichDude = Random.Range(0,enemyGenSeed);
			posA = Vector3(x3*Xspace-6, 2, y3*-Yspace-2);
			posB = Vector3(x3*Xspace-6, 3.1, y3*-Yspace-2);
			if (whichDude < enemyOptions.length){
				whichDude = enemyOptions[whichDude];
			}
			spawnEnemy(whichDude, posB, posA);
			//middle
			whichDude = Random.Range(0,enemyGenSeed);
			posA = Vector3(x3*Xspace, 2, y3*-Yspace+3);
			posB = Vector3(x3*Xspace, 3.1, y3*-Yspace+3);
			if (whichDude < enemyOptions.length){
				whichDude = enemyOptions[whichDude];
			}
			spawnEnemy(whichDude, posB, posA);
			
			
			//pickups
			whichDude = Random.Range(0,itemGenSeed);
			posA = Vector3(x3*Xspace, 1.1, y3*-Yspace);
			if (whichDude< 8){
					Instantiate(pewPickUp, posA, Quaternion.identity);
					}
				else if (whichDude >= 8 && whichDude < 13){
					Instantiate(spreadPickUp, posA, Quaternion.identity);
			}
				else if (whichDude >= 13 && whichDude < 17){
					Instantiate(bubblePickUp, posA, Quaternion.identity);
			}
				else if (whichDude >= 17 && whichDude < 21){
					Instantiate(rocketPickUp, posA, Quaternion.identity);
			}
				else if (whichDude >= 21 && whichDude < 25){
					Instantiate(soakerPickUp, posA, Quaternion.identity);
			}
				else if (whichDude >= 25 && whichDude < 29){
					Instantiate(rockPickUp, posA, Quaternion.identity);
			}
				else if (whichDude >= 29 && whichDude < 32){
					Instantiate(firePickUp, posA, Quaternion.identity);
			}
				else if (whichDude >= 32 && whichDude < 33){
					Instantiate(disintPickUp, posA, Quaternion.identity);
			}
				else if (whichDude >= 33 && whichDude < 48){
					Instantiate(aPylon, posA, Quaternion.identity);
			}
				else if (whichDude >= 38 && whichDude < 43){
					Instantiate(aViking, posA, Quaternion.identity);
			}
				else if (whichDude >= 43 && whichDude < 48){
					Instantiate(aCowboy, posA, Quaternion.identity);
			}
				else if (whichDude >= 48 && whichDude < 53){
					Instantiate(aFootball, posA, Quaternion.identity);
			}
				else if (whichDude >= 53 && whichDude < 58){
					Instantiate(redCap, posA, Quaternion.identity);
			}
				else if (whichDude >= 58 && whichDude < 63){
					Instantiate(grnCap, posA, Quaternion.identity);
			}
				else if (whichDude >= 63 && whichDude < 68){
					Instantiate(bluCap, posA, Quaternion.identity);
			}
				else if (whichDude >= 68 && whichDude < 73){
					Instantiate(prpCap, posA, Quaternion.identity);
			}
				else if (whichDude >= 73 && whichDude < 76){
					Instantiate(vuvuPickUp, posA, Quaternion.identity);
			}
				else if (whichDude >= 76 && whichDude < 81){
					Instantiate(aPope, posA, Quaternion.identity);
			}
				else if (whichDude >= 81 && whichDude < 86){
					Instantiate(aSquid, posA, Quaternion.identity);
			}
				else if (whichDude >= 86 && whichDude < 91){
					Instantiate(aTophat, posA, Quaternion.identity);
			}
				else if (whichDude >= 91 && whichDude < 96){
					Instantiate(aSlug, posA, Quaternion.identity);
			}
				else if (whichDude >= 96 && whichDude < 99){
					Instantiate(spgPickUp, posA, Quaternion.identity);
			}
				else if (whichDude >= 99 && whichDude < 102){
					Instantiate(spcPickUp, posA, Quaternion.identity);
			}
			
			}
			
		}
	}
	if (spawnedEnemyCount == 0){
		posA = Vector3(startX*Xspace+6, 2.1, startY*-Yspace-2);
		posB = Vector3(startX*Xspace+6, 3.1, startY*-Yspace-2);
		spawnGuarantee(posA, posB);
	}
			
	
function addDoors(squareX, squareY){
	aRoom = roomArray[squareX][squareY];
	var endDoorPos;
	if (aRoom% 7 == 0){
		Instantiate(vertDoor, Vector3(checkX*Xspace-11, 3.4, checkY*-Yspace), Quaternion.identity);	
	}
	if (aRoom% 5 == 0){
		Instantiate(vertDoor, Vector3(checkX*Xspace+11, 3.4, checkY*-Yspace), Quaternion.identity);	
	}
	if (aRoom% 3 == 0){
		Instantiate(horizDoor, Vector3(checkX*Xspace, 3.4, checkY*-Yspace-6), Quaternion.identity);	
	}
	if (aRoom% 2 == 0){
		Instantiate(horizDoor, Vector3(checkX*Xspace, 3.4, checkY*-Yspace+6), Quaternion.identity);	
	}
}

function AccessibleRooms(beginX, beginY) {
var anotherRoom = roomArray[beginX][beginY];
roomAccess [beginX][beginY] = 3;
reachableRooms +=1;
print(beginX+","+beginY+" reachable");
if (anotherRoom % 2 == 0 &&  roomAccess[beginX][beginY-1] < 2){
AccessibleRooms(beginX, beginY-1);
}
if (anotherRoom % 3 == 0 &&  roomAccess[beginX][beginY+1] < 2){
AccessibleRooms(beginX, beginY+1);
}
if (anotherRoom % 5 == 0 &&  roomAccess[beginX +1][beginY] < 2){
AccessibleRooms(beginX +1, beginY);
}
if (anotherRoom % 7 == 0 &&  roomAccess[beginX-1][beginY] < 2){
AccessibleRooms(beginX-1, beginY);
}
}

function Start(){
	var enemies = GameObject.FindGameObjectsWithTag("enemy");
	print(enemies.Length+" dudes to kill");
	var keyMaster = Random.Range(0,enemies.Length);
	print("kill guy "+keyMaster);
	print(reachableRooms + " rooms reachable");
	enemies[keyMaster].GetComponent(enemyHealth).setAsKeyMaster();
}
