var walkSpeed = 6.0; 
var directionTraveltime = .5; 
var idleTime = 0.1;
var rndAngle = 90;  // enemy will turn +/- rndAngle

 var timeToNewDirection = 0.0;
 var turningTime = 0.0;
 var turn: float;

 var myTransform : Transform;

function Awake() {
    myTransform = transform;
}

// Cache the controller 
private var characterController : CharacterController; 
characterController = GetComponent(CharacterController);


//------------------------------------------------------------------ 

function Update(){
	if (Time.time > timeToNewDirection) { // time to change direction?
		if(Random.value > 0.5)  // choose new direction
			turn = rndAngle;
		else
			turn = -rndAngle;
		turningTime = Time.time + idleTime; // will stop and turn during idleTime...
		timeToNewDirection = turningTime + directionTraveltime;  // and travel during directionTraveltime 
	}
	if (Time.time < turningTime){ // rotate during idleTime...
		transform.Rotate(0, turn*Time.deltaTime/idleTime, 0);
	} else {  // and travel until timeToNewDirection
		characterController.SimpleMove(transform.forward * walkSpeed);
	}
}

/*var speed: float = 4;
var savedTime = 0;
var moveDirection = Vector3(0,0,0);
var direction: int = 0;


function DecideDirection(seconds){

	direction = Random.Range(0,4);
	switch (direction){
		case 0:
			moveDirection = Vector3(1,0,0);
		break;
		case 1:
			moveDirection = Vector3(0,0,1);
		break;
		case 2:
			moveDirection = Vector3(-1,0,0);
		break;
		case 3:
			moveDirection = Vector3(0,0,-1);
		break;
		}

}

function Update () {
	var controller : CharacterController = GetComponent(CharacterController);
	
		var seconds : int = Time.time;
		var oddeven = (seconds % 2);
		
		if (oddeven){
			DecideDirection(seconds);
		}

    moveDirection *= speed;
    controller.Move(moveDirection );
   // controller.SimpleMove(moveDirection);
}

*/
@script RequireComponent(CharacterController)