var walkSpeed = 3.0; 
var LookAtTarget:Transform;
var damp = 2;
var range = 15;


function Start() {
	var go = GameObject.FindWithTag("Player");
	LookAtTarget =  go.transform;
}

// Cache the controller 
private var characterController : CharacterController; 
characterController = GetComponent(CharacterController);

function Update () {

	if (LookAtTarget)
	{
	
		var seconds : int = Time.time;
		var oddeven = (seconds % 2);
		
		
			var rotate = Quaternion.LookRotation(LookAtTarget.position - transform.position);
			transform.rotation = Quaternion.Slerp(transform.rotation, rotate, Time.deltaTime * damp);
		
			var distance = Vector3.Distance(LookAtTarget.position, transform.position);
			if (distance<range){
				characterController.SimpleMove(transform.forward * walkSpeed);
		}
	}

}

@script RequireComponent(CharacterController)