var LookAtTarget:Transform;
var damp = 0.5;
var bulletPrefab:Transform;
var range = 10;

function Start() {
	var go = GameObject.FindWithTag("Player");
	LookAtTarget =  go.transform;
}


function Update () {

	if (LookAtTarget)
	{
		
		
		var rotate = Quaternion.LookRotation(LookAtTarget.position - transform.position);
		transform.rotation = Quaternion.Slerp(transform.rotation, rotate, Time.deltaTime * damp);
			var distance = Vector3.Distance(LookAtTarget.position, transform.position);
			if (distance<range){
			Shoot();
			}
	}

}

function Shoot(){

		var bullet = Instantiate(bulletPrefab, transform.Find("turrentGun").Find("spawnPoint").transform.position, Quaternion.identity);
		bullet.gameObject.tag = "enemyProjectileFire";
		bullet.rigidbody.AddForce(transform.forward * 1500);
		bullet.rigidbody.AddForce(transform.right * Random.Range(-300.0, 300.0));
}