var capRed : Texture2D;
var capGrn : Texture2D;
var capBlu : Texture2D;
var capPrp : Texture2D;
var blank : Texture2D;

static var CAPSULE = 0;

static var redHealth = false;
static var grnHealth = false;
static var bluHealth = false;
static var prpHealth = false;

static function randomizeColours(){
	var n = Random.Range(0,6);
	switch(n){
		case 0:
			redHealth = true;
			grnHealth = true;
		break;
		case 1:
			redHealth = true;
			bluHealth = true;
		break;
		case 2:
			redHealth = true;
			prpHealth = true;
		break;
		case 3:
			grnHealth = true;
			bluHealth = true;
		break;
		case 4:
			prpHealth = true;
			grnHealth = true;
		break;
		case 5:
			prpHealth = true;
			bluHealth = true;
		break;
	}	
}
			


static function cycleCapsule(aCap){
	CAPSULE = aCap;
}

function Update () {
	switch(CAPSULE){
		case 0:
			guiTexture.texture = blank;
		break;
		case 1:
			guiTexture.texture = capRed;
		break;
		case 2:
			guiTexture.texture = capGrn;
		break;
		case 3:
			guiTexture.texture = capBlu;
		break;
		case 4:
			guiTexture.texture = capPrp;
		break;
	}
}